#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This module can be included.
#
# require 'xorg_buffer/module'; include XorgBuffer
# =========================================================================== #
# require 'xorg_buffer/module.rb'
# =========================================================================== #
module XorgBuffer

  require 'xorg_buffer/constants/constants.rb'

  # ========================================================================= #
  # === XorgBuffer.set_xorg_buffer
  #
  # Use this method to set to the Xorg Buffer, on Linux.
  #
  # Complete usage example for this method here:
  #   require 'xorg_buffer/module'; XorgBuffer.set_xorg_buffer('test')
  #
  # Now, the xorg buffer contains the word 'test'.
  # ========================================================================= #
  def self.set_xorg_buffer(
      data = nil
    )
    if data
      data = data.join('|') if data.is_a? Array
      # ===================================================================== #
      # We must get rid of '""' because this may confuse the xsel command.
      # ===================================================================== #
      if data.include? '"'
        data = data.delete('"')
      end
      # ===================================================================== #
      # We must use 2>&1 in the event that "xsel" is not installed.
      # ===================================================================== #
      cmd = 'echo "'+data+'" | '+USE_THIS_XORG_COMMAND+' 2>&1'
      system cmd
    end
  end; self.instance_eval { alias set_buffer                      set_xorg_buffer } # === XorgBuffer.set_buffer
       self.instance_eval { alias copy_this_text_to_the_clipboard set_xorg_buffer } # === XorgBuffer.copy_this_text_to_the_clipboard
       self.instance_eval { alias copy                            set_xorg_buffer } # === XorgBuffer.copy
       self.instance_eval { alias assign                          set_xorg_buffer } # === XorgBuffer.assign
       self.instance_eval { alias assign_xorg_buffer              set_xorg_buffer } # === XorgBuffer.assign_xorg_buffer
       self.instance_eval { alias set                             set_xorg_buffer } # === XorgBuffer.set
       self.instance_eval { alias []                              set_xorg_buffer } # === XorgBuffer[]

end